//+------------------------------------------------------------------+
//|                                           Serenity EURUSD D1.mq4 |
//+------------------------------------------------------------------+
#property copyright "briandee@selectfx.net"
#property link      "http://www.selectfx.net"


int StopLoss = 0;
int TakeProfit = 0;
extern int MagicNumber = 101100112;
extern double LotSize=0.001;
string MasterSymbol="EURUSD";

extern string Ini.File.Name = "serenity_eurusd.ini";


int Slippage = 25;
extern int OrderRetries = 30;
extern int SleepBetweenTrades = 2000;


extern color Order.Buy.Arrow=Blue;
extern color Order.Buy.Close.Arrow=Green;
extern color Order.Sell.Arrow=Red;
extern color Order.Sell.Close.Arrow=Yellow;

string strComment = "Serenity 1.01 EURUSD";
string strSymbol;
int iPeriod=PERIOD_D1;

string LeftPair="EUR"; // Hard coded for this symbol
string RightPair="USD"; // Hard coded for this symbol

double ActualLotSize;

int Ticket, iNumClosePasses, handle1, ActualSlippage;

string SymbolList[12][3];

#include <stderror.mqh>

/*
1.01
Check on Daily chart /
Deal with Slippage & Pippage across n currencies


*/

//+------------------------------------------------------------------+
//| expert support functions                                         |
//+------------------------------------------------------------------+


int OpenTradesForMN(int MN)
{
int icnt, itotal, retval;

retval=0;
itotal=OrdersTotal();

   for(icnt=0;icnt<itotal;icnt++)
     {
      OrderSelect(icnt, SELECT_BY_POS, MODE_TRADES);
       // check for opened position, symbol & MagicNumber
      if (OrderType()<=OP_SELL)  
          {
           if (OrderMagicNumber()==MN)
             {
               retval++;
        
               //Print("Orders opened : ",retval);
             }
          }
    }

return(retval);
}



  
void WriteIniFile(string strFile)
 {
 

int handle0 = FileOpen(strFile, FILE_CSV|FILE_WRITE, ";");
            
 if (handle0 > 0) 
   {

     FileWrite(handle0, "EURUSD", "0.0001", "Y");
     
     FileWrite(handle0, "EURCHF", "0.0001", "N");
     
     FileWrite(handle0, "USDCHF", "0.0001", "N");
     
     FileWrite(handle0, "USDJPY", "0.01", "N");
     
     FileWrite(handle0, "EURJPY", "0.01", "N");
     
     FileWrite(handle0, "AUDUSD", "0.0001", "N");
     
     FileWrite(handle0, "GBPUSD", "0.0001", "F");
     
     FileWrite(handle0, "EURGBP", "0.0001", "F");
     
     FileWrite(handle0, "XXXXXX", "0.0001", "N");
     
     FileWrite(handle0, "XXXXXX", "0.0001", "N");
     
     FileWrite(handle0, "XXXXXX", "0.0001", "N");
     
     FileWrite(handle0, "XXXXXX", "0.0001", "N");    
     
     FileClose(handle0);

  }  
  
 
 return (0);
 }
 
 
 void LoadSymbolArray(string strFile)
  {

   int x=0;
  
   double handle1=FileOpen(strFile, FILE_CSV|FILE_READ, ";");
 
   if(handle1>0)
    {
     while(FileIsEnding(handle1)==false)  // While the file pointer not at end..
     {  
      // Successive calls to FileReadString pick up chunks ending with the delimiter or the end-of-row
        SymbolList[x][0] = FileReadString(handle1);
        SymbolList[x][1] = FileReadString(handle1);
        SymbolList[x][2] = FileReadString(handle1);
      
      x++;
     } 
      
      FileClose(handle1);
    }
   else 
   {
    Print("INI file missing: ", strFile);
    return (0);
   }

  
  return(0);
  }
  

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----

  int handle, size;
  
  handle=FileOpen(Ini.File.Name, FILE_READ);
  
  if(handle>0) // file exists
    {
     size=FileSize(handle);

     FileClose(handle);
    }

   else  WriteIniFile(Ini.File.Name); // not there so create it
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
  

  
  
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----

double dMasterDirection;
string strSymbolFromArray, strCorrelation, strPipPoint;
int x, iStrengthenPosition;

//================================= Every Tick START ===============================
      strSymbol = Symbol();
      
      ActualLotSize = MathMax(MarketInfo(strSymbol, MODE_MINLOT), ActualLotSize);
      
     
      

//================================= Every Tick END =================================


  if (Volume[0]>1) return(0); // Quit if after first tick of bar

 
         iNumClosePasses = OrderRetries;
          
         while ((iNumClosePasses > 0) && (OpenTradesForMN(MagicNumber) > 0))
           {
            CloseAllBuyOrders(MagicNumber); //Close any Buy orders this Expert opened
            CloseAllSellOrders(MagicNumber); //Close any Sell orders this Expert opened
            
            iNumClosePasses--;
           }
           
          
         LoadSymbolArray(Ini.File.Name);
          
         dMasterDirection = iClose(MasterSymbol,PERIOD_D1,1)-iClose(MasterSymbol,PERIOD_D1,2);
          

         for(x=0;x<12;x++)
           {
           
            strSymbolFromArray=SymbolList[x][0];
            strPipPoint = SymbolList[x][1];
            strCorrelation = SymbolList[x][2];
            
            
            // Print("str0: ", strSymbolFromArray, " str1: ", strCorrelation);
            
            if (strSymbolFromArray != "XXXXXX") 
              {
               if (strCorrelation!= "F")
            
                { 
                  if(StrToDouble(strPipPoint) > Point) ActualSlippage = Slippage*10; // got sub-pip pricing
                  else ActualSlippage = Slippage;
                  
                  if ((dMasterDirection > 0) && (strCorrelation=="Y")) Ticket = OpenAtMarketSLZTPZ (strSymbolFromArray, OP_BUY, ActualLotSize, ActualSlippage, StopLoss, TakeProfit, strComment+" "+strSymbolFromArray, MagicNumber, 0, Order.Buy.Arrow, OrderRetries, SleepBetweenTrades);
 
                  if ((dMasterDirection < 0) && (strCorrelation=="Y")) Ticket = OpenAtMarketSLZTPZ (strSymbolFromArray, OP_SELL, ActualLotSize, ActualSlippage, StopLoss, TakeProfit, strComment+" "+strSymbolFromArray, MagicNumber, 0, Order.Sell.Arrow, OrderRetries, SleepBetweenTrades);
         
                  if ((dMasterDirection < 0) && (strCorrelation=="N")) Ticket = OpenAtMarketSLZTPZ (strSymbolFromArray, OP_BUY, ActualLotSize, ActualSlippage, StopLoss, TakeProfit, strComment+" "+strSymbolFromArray, MagicNumber, 0, Order.Buy.Arrow, OrderRetries, SleepBetweenTrades);
 
                  if ((dMasterDirection > 0) && (strCorrelation=="N")) Ticket = OpenAtMarketSLZTPZ (strSymbolFromArray, OP_SELL, ActualLotSize, ActualSlippage, StopLoss, TakeProfit, strComment+" "+strSymbolFromArray, MagicNumber, 0, Order.Sell.Arrow, OrderRetries, SleepBetweenTrades);
            
                } 
              }
          }

         
  
       
//----
   return(0);
  }
//+------------------------------------------------------------------+



int OpenAtMarketSLZTPZ (string strPair, int iOrderType, double dLots, int iSlippage, int iStopLossPips, int iTakeProfitPips, string strOrderComment, int iMagicNumber, datetime dtExpiry, color cColour, int iNR, int iMTS)
{
 int iMaxNumRetries, iNumRetries=iNR;
 double dPrice, dSL, dTP;
 
    // is server or context busy - try n times to submit the order
    iNumRetries=iNR;
    
     if(iOrderType > OP_SELL)
      {
        Print("OpenAtMarket Error: OrderType is a Pending Order!");
        return(0);
      }
     
    while(iNumRetries>0)
    {
        RefreshRates();
        if(iOrderType==OP_BUY) 
          {
           dPrice=NormalizeDouble(MarketInfo(strPair, MODE_ASK), Digits);
           
           if (iStopLossPips==0) dSL = 0;
           else dSL=NormalizeDouble(dPrice-iStopLossPips*Point, Digits);
           
           if (iTakeProfitPips==0) dTP = 0;
           else dTP=NormalizeDouble(dPrice+iTakeProfitPips*Point, Digits);
          }
          
        if(iOrderType==OP_SELL) 
           {
            dPrice=NormalizeDouble(MarketInfo(strPair, MODE_BID), Digits);
            
            if (iStopLossPips==0) dSL = 0;
            else dSL=NormalizeDouble(dPrice+iStopLossPips*Point, Digits);
            
            if (iTakeProfitPips==0) dTP = 0;
            else dTP=NormalizeDouble(dPrice-iTakeProfitPips*Point, Digits);           
           }
    
        int iTicket =  OrderSend(strPair, iOrderType, dLots, dPrice, iSlippage, dSL, dTP, strOrderComment, iMagicNumber, dtExpiry, cColour);
 
        iNumRetries--;
 
        if(iTicket == -1 )
        {
            int iError = GetLastError();
 
            // retry if error is "busy", otherwise give up
            if(iError==ERR_SERVER_BUSY || iError==ERR_TRADE_CONTEXT_BUSY || iError==ERR_BROKER_BUSY || iError==ERR_NO_CONNECTION 
            || iError==ERR_TRADE_TIMEOUT || iError==ERR_INVALID_PRICE || iError==ERR_OFF_QUOTES || iError==ERR_PRICE_CHANGED || iError==ERR_REQUOTE)
                Sleep(iMTS);
            else
            {
                iNumRetries = 0;
                Print("OpenAtMarket Error: ", iError );
            }
        }
        else
            iNumRetries = 0;
    }
 
    return(iTicket);
}


void CloseAllBuyOrders(int MN)
  {
  int i, iTotalOrders;
  
  //iTotalOrders=OrdersTotal(); 
  //for (i=0; i<iTotalOrders; i++)
   
   iTotalOrders=OrdersTotal()-1; // Rosh line
  
   for (i=iTotalOrders; i>=0; i--) // Rosh line     
   
   { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      { 
         if (OrderMagicNumber()==MN)
         { 
            if (OrderType()==OP_BUY) OrderClose(OrderTicket(),OrderLots(),Bid,5,Order.Buy.Close.Arrow);
            if (OrderType()==OP_BUYSTOP) OrderDelete(OrderTicket());
            if (OrderType()==OP_BUYLIMIT) OrderDelete(OrderTicket());
            
         }
      }
   }
}

void CloseAllSellOrders(int MN)
  {
  int i, iTotalOrders;
  
  //iTotalOrders=OrdersTotal(); 
  //for (i=0; i<iTotalOrders; i++)
   
   iTotalOrders=OrdersTotal()-1; // Rosh line
  
   for (i=iTotalOrders; i>=0; i--) // Rosh line     
   
   { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      { 
         if (OrderMagicNumber()==MN)
         { 
            if (OrderType()==OP_SELL) OrderClose(OrderTicket(),OrderLots(),Bid,5,Order.Sell.Close.Arrow);
            if (OrderType()==OP_SELLSTOP) OrderDelete(OrderTicket());
            if (OrderType()==OP_SELLLIMIT) OrderDelete(OrderTicket());
            
         }
      }
   }
}





